# Thincast Remote Desktop Web Services
## Changelog

### Version 1.3.1320.0 (May 30, 2025)
* 2FA: Fix issue where authenticator app registrations created under pre 1.3 RD WebServices versions were rejected.

### Version 1.3.1316.0 (May 29, 2025)
* Linux: Fix startup problem when IPv4/IPv6 dual stack is enabled.

### Version 1.3.1310.0 (May 28, 2025)
* RD WebClient: Initial release.
* Core: Allow to temporarily disable 2FA for a user.
* Core: If a Wake on Lan (WOL) packet is sent, try to connect to the remote computer 6 times before giving up.
* Core: Allow to import Wake on Lan (WOL) entries from a cvs file.
* Core: Added backup functionality.
* Core: NPS (Network Policy Server) support.

### Version 1.2.1064.0 (September 18, 2024)
* Core: Changed write behaviour of file logger to avoid missinterpredation of some realtime log viewer.
* Core: Added robots.txt to prevent bots from indexing RD WebServices.

### Version 1.2.1064.0 (September 18, 2024)
* Linux: Fixed possible openssl issue while requesting an acme certificate. 
* Linux: Fixed an issue with certificates issued over the acme protocol, where external set certificates (commandline) overruled the acme generated ones.

### Version 1.2.1058.0 (July 26, 2024)
* Linux: Add support for Ubuntu 24.04 (Noble Numbat).

### Version 1.2.1052.0 (July 17, 2024)
* RD WebServices GUI: Minor fixes.
* RD WebAccess: Added intermediate certificates, if present, in rdp file signing.

### Version 1.2.1050.0 (June 20, 2024)
* RD Gateway: Added Wake on Lan support.

### Version 1.2.1028.0 (May 27, 2024)
* RD Gateway (Windows only): Added Windows Event Log logger.

### Version 1.2.1022.0 (May 07, 2024)
* RD Advanced Security: Resolved an issue following new maxmind geoip download redirects.

### Version 1.2.1018.0 (March 25, 2024)
* RD Gateway: Resolved an issue causing inaccurate connection counts.

### Version 1.2.1016.0 (March 04, 2024)
* Linux: Fix persisting behavior of enums, which could prevent service startup.

### Version 1.2.1014.0 (February 22, 2024)
* Linux: Fix string parsing for NTLM authentication packets, which could lead to authentication failure.

### Version 1.2.988.0 (February 13, 2024)
* Core: Workaround for Microsoft Android client sending misformed URIs.

### Version 1.2.984.0 (February 08, 2024)
* Linux: Fixed possible buffer overrun.
* Linux: Fixed issue which could prevent ACME HTTP server to start.

### Version 1.2.976.0 (December 21, 2023)
* RD WebServices GUI: Fixed line-ending handling with gateway Logon Message and gateway System Message gui.

### Version 1.2.974.0 (December 14, 2023)
* RD WebServices GUI: Minor fixes.

### Version 1.2.971.0 (December 13, 2023)
* Added new add-on RD Advanced Security supporting:
  * GeoIp Protection
  * Brute Force Protection
  * Logon Hours restriction for users/groups
  * Lets encrypt support
* Core: Added client ip over reverse proxy support.
* RD WebAccess Web App: added idle timeout
* 2FA: added Relaxed 2FA Time, so no 2FA authentication is needed from the same host and user within this time.
* Linux: Add support for Debian 12 (bookworm)
* CLI: add cli for linux user management

### Version 1.1.812.0 (August 28, 2023)
* RD Gateway: Fix connection drops which may occur with low bandwidth connections.

### Version 1.1.808.0 (April 25, 2023)
* Added Two Factor Authentication support (RD Gateway and RD WebAccess), using Thincast Authenticator.
* RD WebAccess: Added configuration options for WebFeed name and description.

### Version 1.1.792.0 (March 22, 2023)
* Core: Add possibility to overwrite hostname if a wildcard certificate is used.

### Version 1.1.778.0 (February 06, 2023)
* Linux: Add support for Ubuntu 22.10 (kinetic), which will be the last non LTS version supported.
* Linux: Removed support for Ubuntu 21.10 (Impish Indri).
* Core: Major rework of transport subsystem.
* Feature: Add generator for sha265key key.
* RD WebServices GUI: Minor fixes and improvements.

### Version 1.0.598.0 (July 05, 2022)
* RD WebApp: Changed thrift handler url.
* Core: Fixed vulnerability: SSL/TLS: Renegotiation DoS Vulnerability (CVE-2011-1473, CVE-2011-5094).

### Version 1.0.598.0 (July 05, 2022)
* Core: Fixed data handling, if a reverse proxy (HAProxy for example) used.
* Core: Added fast status page to allow fast checking if the service is online (url: /status).

### Version 1.0.588.0 (April 05, 2022)
* Core: Fixed bug in certificate handling, which could prevent the service start.
* RD WebAccess GUI: Fixed bug in WebAccess Remote Connection multi edit, where the session bpp gets lost.

### Version 1.0.582.0 (March 18, 2022)
* Core: Fixed bug, which could lead to a server crash.
* Core: Fixed bug, where all Network events where logged, even if the logging for a specific event was disabled.
* Core: Silence server hint (http response header 'server' removed) in http response.
* Core: Drop client connection silent in case of error (do not write back error 500).
* Core: Log network error event if a miss formed http request was received.

### Version 1.0.580.0 (March 16, 2022)
* Core: Hardend config file management.
* Linux: Add support for Ubuntu 21.10 (Impish Indri).
* Core: Fixed bug, where no new log file was opened, in rolling logging files.
* Upgrade dependency: Using OpenSSL 1.1.1n now.

### Version 1.0.550.0 (November 11, 2021)
* Feature: Added update check in the RD WebServices Manager if its installed without the service (Stand Alone).

### Version 1.0.542.0 (September 24, 2021)
* Feature: Restrict administrative connections by ip addresses or ip ranges.
* Feature: RD WebAccess Gui - Allow copy of RD WebAccess Resources.
* Feature: Added Network Event logging.
* Feature: Network Event logging and RD Gateway Access logging use rolling logging files now.
* Installer Windows: Check if server port 443 is available, otherwise let the user choose the server port.

### Version 1.0.520.0 (July 30, 2021)
* Core: Fixed websocket bug if packet size was over 1680 bytes.

### Version 1.0.518.0 (July 14, 2021)
* Core: Upgraded boost to version 1.76.
* Core: Upgraded cpprestsdk to version 2.10.18.
* Core: TLSv1.0 is now disabled per default.
* Core: All TLS protocol version (1.0, 1.1, 1.2 and 1.3) can be enable or disable in the config if needed.
* Installer: Dropped X86 support.

### Version 1.0.466.0 (May 06, 2021)
* Core: Hardend config file handling.
* Upgrade dependencies: Using Qt5 v5.15.2 and OpenSSL 1.1.1k now.
* Core: Fixed ERR_SSL_KEY_USAGE_INCOMPATIBLE error in chrome.

### Version 1.0.408.0 (March 12, 2021)
* RD WebAccess: Added missing rdp file setting 'bandwidthautodetect'.

### Version 1.0.406.0 (March 11, 2021)
* RD Gateway: Workaround for the Microsoft Mac Remote Desktop Client, which disconnected in chunked transfer mode.
* RD Gateway: Workaround for the Microsoft Mac Remote Desktop Client, which tried to reconnect on disconnect in websocket transfer mode.
* RD Gateway: Fixed a bug if RD Gateway packets arrive fragmented.
* RD WebServices Lite: Fixed a bug which prevented startup.

### Version 1.0.396.0 (February 23, 2021)
* RD Gateway: Allow in Server Policies, NetBios names or DNS names instead of ip host addresses.
* RD WebAccess: Fixed a bug where a shortend resources list was generated if user accounts where added directly to an access list.
* RD WebAccess GUI: Fixed a display bug if 'Detect connection quality automatically' was selected in the Experience tab.

### Version 1.0.388.0 (February 17, 2021)
* Core: Added WebSocket support.
* Core: Limit http header and body read size.
* RD Gateway: Upgrade to WebSocket transport if offered by the rdp client.
* RD Gateway GUI: Added transport type of a gateway connection in the monitoring tab.

### Version 1.0.386.0 (February 09, 2021)
* RD Gateway: Fixed possible race condition if statistics for the admin where generated.
* RD Gateway: The RD Gateway transport is now lockfree, which results in increased throughput.
* Core: Various speed optimizations.
* Core: Hardend multithreaded memory handling and pointer access.
* RD WebApp: Fix footer location.

### Version 1.0.354.0 (January 22, 2021)
* RD Gateway: Workaround for the Microsoft Mac Remote Desktop Client, who disconnects if a HTTP_DATA_PACKET packet is larger than 16384 bytes.
* RD Gateway GUI: Fixed administrative message input.

### Version 1.0.350.0 (January 20, 2021)
* RD WebServices GUI: Fixed tab order. Fixed tabbing which got stuck within tables.
* RD WebServices GUI: Trim each user or group separately, if multiple users or groups are selected at once.
* RD WebAccess GUI: Fixed multiedit of RD WebAccess Remote Connections.
* RD WebServices GUI: Added menu keyboard shortcuts.
* RD Gateway GUI: Fixed bug which let elements be editable, even Logon Message or System Message where disabled.
* RD Gateway GUI: Client Policies: Remove unused 'Support Windows authentication methods' for now.
* RD WebAccess GUI: Remote Connections: Filter out unsupported characters from the title and replace them with underscore.
* Core: Fixed crash if a second instance of RD WebServices was started with Thincast Workstation AddOn enabled.
* RD WebAccess GUI: Thincast Workstation AddOn: Last error was still shown, even reconnect was successful.
* RD WebAccess: Fixed controlling Thincast Workstation AddOn in demo mode.
* RD WebAccess: Fixed bug where gateway usage was rendered 'automatic' instead of 'disabled'.
* RD WebAccess: Let connected admin account download rdp files through the admin GUI, even the admin account is not in the RD WebAccess AllowList.
* TCSupport: Remove encrypted TC Workstation AddOn credentials before uploading.

### Version 1.0.342.0 (December 23, 2020)
* Installer-x64: If a custom path was used, the installed msi file was not deleted after finishing the installation.
* RD WebServices GUI: Beautify error message if update server is not reachable.
* Core: Fixed certificate handling if a chain is present.
* Core: If a sha265key is changed, no restart is required anymore.
* RD WebAccess: Disable WebApp handler if RD WebAccess is disabled.

### Version 1.0.334.0 (December 02, 2020)
* Core: Fixed bug in creation of self signed certificates.
* Installer: Fixed a update bug, where self signed certificate name was asked, even a certificate was already present. 

### Version 1.0.330.0 (November 30, 2020)
* Core: Fixed bug preventing resource download, if resource sets a newly added gateway server before saving.
* GUI: Trim and limit user input.

### Version 1.0.326.0 (November 27, 2020)
* Update: Reworked update mechanism. The admin GUI checks now the RD WebServices server version on each connect to a server.

### Version 1.0.310.0 (November 16, 2020)
* Core: fixed import of PFX files.

### Version 1.0.308.0 (November 09, 2020)
* RD WebAccess: Added RDP signing feature.
* RD WebAccess: Added missing redirection location if auth cookie is not present for png, icon and rdp files.
* Core: Fixed demo license handling.
* Core: Improved stability.
* RD Gateway GUI: Added Logon Message tab with updated GUI.
* RD WebAccess GUI: Added Overview Tab with rdp signing setting.

### Version 1.0.286.0 (October 02, 2020)
* Core: Fixed possible race condition.
* Logging: Improved logging.

### Version 1.0.276.0 (September 17, 2020)
* User Management: Fixed resolving of Active Directory groups.

### Version 1.0.274.0 (September 16, 2020)
* Certificate: Remove bom from certificate files (unsupported by openssl) if present.

### Version 1.0.272.0 (September 14, 2020)
* RD Gateway: Fixed port handling in Computer Policies.
* User Management: Fixed Active Directory User and Group listing.

### Version 1.0.268.0 (August 12, 2020)
* Licensing: Fixed saving the username, if 'Remember Username' is checked.

### Version 1.0.266.0 (August 11, 2020)
* RD WebServices: Fixed permissions of the config folder.
* TCSupport: Filter out sensitive information before uploading a report.
* Licensing: Fixed bug displaying wrong status if license has expired.

### Version 1.0.260.0 (August 11, 2020)  
* Initial release.
